/* Pierre BETOUIN <pierre.betouin@security-labs.org> 	*/
/* 04/22/2006 13:38:48 (UTC+0200)			*/
/* OPCODE FINDER - Search opcode in process and/or	*/
/* dump its process memory				*/

/* Copyright (C) 2006 Pierre BETOUIN
 * 
 * Written 2006 by Pierre BETOUIN <pierre.betouin@security-labs.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT OF THIRD PARTY
 * RIGHTS.  IN NO EVENT SHALL THE COPYRIGHT HOLDER(S) AND AUTHOR(S) BE LIABLE
 * FOR ANY CLAIM, OR ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY
 * DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * ALL LIABILITY, INCLUDING LIABILITY FOR INFRINGEMENT OF ANY PATENTS,
 * COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS, RELATING TO USE OF THIS SOFTWARE
 * IS DISCLAIMED.
*/

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <unistd.h>
#include <asm/page.h>
#include <sys/mman.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/ptrace.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
	FILE *mem = NULL;
	FILE *output=NULL;
	char p[64];
	char byte;
	unsigned long i = 0;
	unsigned long addr, addr2; 
	int pid = 0;

	if(argc < 5)
	{
		fprintf(stderr, "Usage: %s <start address> <end address> <pid> <output file>\n", argv[0]);
		exit(EXIT_FAILURE);
	}
	
	addr = strtoul(argv[1], NULL, 16);
	addr2 = strtoul(argv[2], NULL, 16);
	pid = atoi(argv[3]);
	
	if( (addr2 <= addr) || (addr <=0 ) || (addr2 <= 0) )
	{
		fprintf(stderr, "Error: <end address> must be greater than <start address> and both values must be positive\n");
		exit(EXIT_FAILURE);
	}
	
	snprintf(p, 63, "/proc/%d/mem", pid);
	ptrace(PTRACE_ATTACH, pid, 0, 0);
	sleep(1);

	if ( !(mem = fopen(p, "r"))) 
		perror("fopening process' memory file)");
	
	if (!fseek(mem, addr, SEEK_SET) < 0) 
		perror("fseeking process' memory file");

	output=fopen(argv[4],"wb");
	
	while(addr != addr2)
	{
		i=fread(&byte, 1, 1, mem);
//		printf("%.02X ", (unsigned char) byte);
		fprintf(output, "%c",(unsigned char)byte);
		addr++;
	}
	
	fclose(mem);
	fclose(output);
	ptrace(PTRACE_DETACH,atoi(argv[3]),0,0);

	return 0;
}
