#! /usr/bin/env python
#
# Pierre BETOUIN <pierre.betouin@security-labs.org>
# http://securitech.homeunix.org
# OPCODE finder in a binary file (memory dump for instance)
#
# Usage: ./opcode_file_finder.py <file> <starting address>
# 
# Starting address depends if you want to "map" the virual address at launch time. If you're just searching
# for an offset, then specify 0.
# 
# !!!!! Don't forget to replace the find_opcode function first argument 
# with the OPCODE(s) you are searching for

# Linux X86 OPCODE(s)
# \xFF\xD0	call %eax
# \xFF\xD3	call %ebx 
# \xFF\xD4	call %esp
# \xFF\xD5	call %ebp
# \x58		pop %eax
# \x59		pop %ecx
# \x5b		pop %ebx
# \ffe2		jmp %edx
# \xFF\x55\x9C	call [ebp-100]

# Other OPCODES in Ressources/template.asm
# 

import os, sys, string, StringIO

def find_opcode(opcode, file, address):
	try:
		l = open(file)
		mem = l.read(os.path.getsize(file))	# the length to read is the file size...
		pos = mem.find(opcode)
		if pos < 0:
			print "Not found"
		else:
			print "Found at 0x%lx" % (address+pos)
	finally:
		print "-- end --"


if __name__ == "__main__":
	if not sys.argv[2:]:
		sys.stdout.write("Sorry: you must specify at least 2 arguments : <binary file> <base address : cf /proc/[pid]/maps>\n")
		sys.stdout.write("	You also need to edit this script to change the OPCODE(s) you are searching for.\n")
		sys.exit(0)
	
	print find_opcode("\xFF\xD0", sys.argv[1], string.atoi(sys.argv[2], 16))
	
